/*#define TRACE*/

void do_unimp();
void do_add();
void do_addi();
void do_addu();
void do_addui();
void do_and();
void do_andi();
void do_beqz();
void do_bfpf();
void do_bfpt();
void do_bnez();
void do_j();
void do_jal();
void do_jalr();
void do_jr();
void do_lb();
void do_lbu();
void do_ld();
void do_lf();
void do_lh();
void do_lhi();
void do_lhu();
void do_lw();
void do_movd();
void do_movf();
void do_movfp2i();
void do_movi2fp();
void do_movi2s();
void do_movs2i();
void do_or();
void do_ori();
void do_rfe();
void do_sb();
void do_sd();
void do_seq();
void do_seqi();
void do_sequ();
void do_sequi();
void do_sf();
void do_sge();
void do_sgei();
void do_sgeu();
void do_sgeui();
void do_sgt();
void do_sgti();
void do_sgtu();
void do_sgtui();
void do_sh();
void do_sle();
void do_slei();
void do_sleu();
void do_sleui();
void do_sll();
void do_slli();
void do_slt();
void do_slti();
void do_sltu();
void do_sltui();
void do_sne();
void do_snei();
void do_sneu();
void do_sneui();
void do_sra();
void do_srai();
void do_srl();
void do_srli();
void do_sub();
void do_subi();
void do_subu();
void do_subui();
void do_sw();
void do_trap();
void do_xor();
void do_xori();
void do_nop();

#define OP_UNIMP 	 112
#define OP_RES 		 113
#define OP_LAST 	 114

/*
 * OpCode values for MemWord structs.  These are straight from the MIPS
 * manual except for the following special values:
 *
 * OP_NOT_COMPILED -	means the value of the memory location has changed
 *			so the instruction needs to be recompiled.
 * OP_UNIMP -		means that this instruction is legal, but hasn't
 *			been implemented in the simulator yet.
 * OP_RES -		means that this is a reserved opcode (it isn't
 *			supported by the architecture).
 */

#define OP_ADD 		 1
#define OP_ADDI 	 2
#define OP_ADDU 	 3
#define OP_ADDUI 	 4
#define OP_AND 		 5
#define OP_ANDI 	 6
#define OP_BEQZ 	 7
#define OP_BFPF 	 8
#define OP_BFPT 	 9
#define OP_BNEZ 	 10
#define OP_J 		 11
#define OP_JAL 		 12
#define OP_JALR 	 13
#define OP_JR 		 14
#define OP_LB 		 15
#define OP_LBU 		 16
#define OP_LD 		 17
#define OP_LF 		 18
#define OP_LH 		 19
#define OP_LHI 		 20
#define OP_LHU 		 21
#define OP_LW 		 22
#define OP_MOVD 	 23
#define OP_MOVF 	 24
#define OP_MOVFP2I 	 25
#define OP_MOVI2FP 	 26
#define OP_MOVI2S 	 27
#define OP_MOVS2I 	 28
#define OP_OR 		 29
#define OP_ORI 		 30
#define OP_RFE 		 31
#define OP_SB 		 32
#define OP_SD 		 33
#define OP_SEQ 		 34
#define OP_SEQI 	 35
#define OP_SEQU 	 36
#define OP_SEQUI 	 37
#define OP_SF 		 38
#define OP_SGE 		 39
#define OP_SGEI 	 40
#define OP_SGEU 	 41
#define OP_SGEUI 	 42
#define OP_SGT 		 43
#define OP_SGTI 	 44
#define OP_SGTU 	 45
#define OP_SGTUI 	 46
#define OP_SH 		 47
#define OP_SLE 		 48
#define OP_SLEI 	 49
#define OP_SLEU 	 50
#define OP_SLEUI 	 51
#define OP_SLL 		 52
#define OP_SLLI 	 53
#define OP_SLT 		 54
#define OP_SLTI 	 55
#define OP_SLTU 	 56
#define OP_SLTUI 	 57
#define OP_SNE 		 58
#define OP_SNEI 	 59
#define OP_SNEU 	 60
#define OP_SNEUI 	 61
#define OP_SRA 		 62
#define OP_SRAI 	 63
#define OP_SRL 		 64
#define OP_SRLI 	 65
#define OP_SUB 		 66
#define OP_SUBI 	 67
#define OP_SUBU 	 68
#define OP_SUBUI 	 69
#define OP_SW 		 70
#define OP_TRAP 	 71
#define OP_XOR 		 72
#define OP_XORI 	 73
#define OP_NOP       74

#define SPECIAL 120
#define FPARITH	121

#define IFMT 1
#define JFMT 2
#define RFMT 3

extern int rs1, rs2, rd, extra, func;

#define HALT_TRAP 0

#define KBD_READ_TRAP 0x3
#define SCREEN_WRITE_TRAP 0x4

#define NO_MEM_TRAP 0x10
#define MISALIGNED_TRAP 0x11

#define OVERFLOW_TRAP 0x20

#define UNIMP_TRAP 0x30

#define FP_TRAP 0x40

#define IBPT_TRAP 0x51
#define RBPT_TRAP 0x52
#define WBPT_TRAP 0x53

#define PANIC_TRAP 0x8000

#define TRAP_MASK 0xffff
#define FLAG_MAS 0x3ff0000

#define MEM_READ_FLAG 0x10000
#define MEM_WRITE_FLAG 0x20000
#define MEM_FETCH_FLAG 0x40000

#define READ_BPT 0
#define WRITE_BPT 1
#define FETCH_BPT 2

extern int trapNo;
extern int trapAddr;

#define ATTN_SIG SIGINT
extern int gotInt;
extern int ignoreBpt;

#define MEM_SIZE 1024*4
extern unsigned char *mem;
#define imem(x) (*((unsigned int*)(mem + x)))  /* Endian */
#define smem(x) (*((unsigned short*)(mem + x))) /* Endian */

extern int comms_sock[2];

/* sim.c */

extern int *regs;
extern int using_x;
extern int is_tty;
#define PC 32
#define OLD_PC 33
#define NREGS (OLD_PC+1)
#define pc regs[PC]
#define oldpc regs[OLD_PC]

int init(int msize);
void stop(void);

/* mem.c */
int WMem(int value, unsigned int locn, int size);
int FetchMem(unsigned int *value, unsigned int locn);
int RMem(unsigned int *value, unsigned int locn, int size);

/* action.c */
int writeReg(int value, int reg);

/* break.c */
typedef struct breakPoint
{
 int type;
 int locn;
 struct breakPoint *next;
} breakPoint;

extern breakPoint *bptLists[3];  /* List of each type of bpt */
extern breakPoint *bptTails[3];

extern int numBpts[3];  /* Number of each type of breakpoint
			   (read, write, fetch) */

void addBpt(int locn, int type);
int chkBpt(int locn, int type, int size);
void rmBpt(int locn, int type);
void rmBptNo(int num, int type);
breakPoint *bList(int type);
void clearAllBpts(void);

/* comms.c */
char *NumOut(int N, char radix, int unsignd);
